#ifndef _FOPEN_C
#define _FOPEN_C

/* Creating programs on the TI83
   !!! VERY BETA'ish !!!

Question:
     o Is PROGOBJ 05h or F5h ??? I've got two different doc's
       about this...
 */

/* fopen("BLA","r") */
r_fopen(str) char *str;
{
#asm
	_createprog	.equ	448Ah	; Makes things easier for us.
	tprgm		.equ	$5F	; Wasn't defined in tokens.inc
	PROGOBJ		.equ	05h	; Our variable type.

	call	_zerooop1		; Set Op1 to zero
	ld	hl,2			; The string-pointer is
	add	hl,sp			;  at SP+2.
	call	LD_HL_MHL		; HL = pointer at (HL)
					;
	ld	de,OP1			; DE = adress of OP1
	ld	a,PROGOBJ		; The object type is 'program'
	ld	(de),a			; Store it in first byte of OP1
	ld	b,9			; Maximum B-1 bytes to copy
					;
r_fopen_loop:
	inc	de			; next byte of OP1
	ld	a,(hl)			; get a byte of the string
	or	a			; if(A = 0), done copying
	jr	z,next_r_fopen		;  goto next label
	ld	(de),a			; Store the byte in OP1+xx
	inc	hl			; Next byte of string
	dec	b			; Maximum B-1 times again
	jr	z,error_r_fopen		; if(B = 0), ERROR!
	jr	r_fopen_loop		; go back for next character
					;
	call	_chkfindsym		; look it up
	ld	hl,0			;
	ret	c			; if(error), return(0)
	inc	de			; skip 1st length byte
	inc	de			; skip 2nd length byte
	ex	de,hl			; return the pointer to the program
#endasm
}


/* fopen("BLA","w") */
w_fopen(str) char *str;
{
#asm
	_createprog	.equ	448Ah	; Makes things easier for us.
	tprgm		.equ	$5F	; Wasn't defined in tokens.inc
	PROGOBJ		.equ	05h	; Our variable type.

	call	_zerooop1		; Set Op1 to zero
	ld	hl,2			; The string-pointer is
	add	hl,sp			;  at SP+2.
	call	LD_HL_MHL		; HL = pointer at (HL)
					;
	ld	de,OP1			; A = adress of OP1
	ld	a,PROGOBJ		; The object type is 'program'
	ld	(de),a			; Store it in first byte of OP1
	ld	b,9			; Maximum B-1 bytes to copy
					;
w_fopen_loop:
	inc	de			; next byte of OP1
	ld	a,(hl)			; get a byte of the string
	or	a			; if(A = 0), done copying
	jr	z,next_w_fopen		;  goto next label
	ld	(de),a			; Store the byte in OP1+xx
	inc	hl			; Next byte of string
	dec	b			; Maximum B-1 times again
	jr	z,error_w_fopen		; if(B = 0), ERROR!
	jr	w_fopen_loop		; go back for next character
					;
	call	_chkfindsym		; look it up
	call	nc,_delvar		; if it is there delete it (to keep things clean)
	ld	hl,1			; our program, with no data has only 1 byte as body
	call	_createprog		; create it
	inc	de			; skip 1st length byte
	inc	de			; skip 2nd length byte
	ex	de,hl			; return the pointer to the program
#endasm
}

/* fopen("BLA","a")  NOT FINISHED !!!*/
a_fopen(str) char *str;
{
#asm
	_createprog	.equ	448Ah	; Makes things easier for us.
	tprgm		.equ	$5F	; Wasn't defined in tokens.inc
	PROGOBJ		.equ	05h	; Our variable type.

	call	_zerooop1		; Set Op1 to zero
	ld	hl,2			; The string-pointer is
	add	hl,sp			;  at SP+2.
	call	LD_HL_MHL		; HL = pointer at (HL)
					;
	ld	de,OP1			; A = adress of OP1
	ld	a,PROGOBJ		; The object type is 'program'
	ld	(de),a			; Store it in first byte of OP1
	ld	b,9			; Maximum B-1 bytes to copy
					;
a_fopen_loop:
	inc	de			; next byte of OP1
	ld	a,(hl)			; get a byte of the string
	or	a			; if(A = 0), done copying
	jr	z,next_a_fopen		;  goto next label
	ld	(de),a			; Store the byte in OP1+xx
	inc	hl			; Next byte of string
	dec	b			; Maximum B-1 times again
	jr	z,error_a_fopen		; if(B = 0), ERROR!
	jr	a_fopen_loop		; go back for next character
					;
	call	_chkfindsym		; look it up
	call	nc,_delvar		; if it is there delete it (to keep things clean)
	ld	hl,1			; our program, with no data has only 1 byte as body
	call	_createprog		; create it
	inc	de			; skip 1st length byte
	inc	de			; skip 2nd length byte
	ex	de,hl			; return the pointer to the program
#endasm
}

/* The code from ASMGuru:

	_createprog	.equ 448Ah		; Makes things easier for us.
	tprgm		.equ $5F		; Wasn't defined in tokens.inc
	PROGOBJ		.equ 05h		; Our variable type.


	call	_clrLCDFull	; Clear screen.
	call	_homeup		; Home up.
	ld	hl,create
	call	_puts
	call 	_newline
	ld	hl,asmcreate
	call	_puts
	call 	_zerooop1	; Set Op1 to zero
	ld	hl,progname1	; the name of the prog
	ld	de,op1		; copy it to op1
	ld	bc,7		; 7 chars in name

	ldir			; do the copying
	call	_chkfindsym	; look it up
	call	nc,_delvar	; if it is there delete it (to keep things clean)
	ld	hl,17		; length of program (in bytes)
	call	_createprog	; create it
	inc	de		; skip 1st length byte
	inc	de		; skip 2nd length byte
	ld	hl,prog1	; program data
	ld	bc,17		; program data length
	ldir			; copy data

	call	_newline
	ld	hl,basiccreate
	call	_puts

	call	_zerooop1		
	ld	hl,progname2	; the name of the prog
	ld	de,op1		; copy it to op1
	ld	bc,8		; 8 chars in name
	ldir			; do the copying
	call	_chkfindsym	; look it up
	call	nc,_delvar	; if it is there delete it (to keep things clean)
	ld	hl,9		; length of program (in bytes)
	call	_createprog	; create it
	inc	de		; skip 1st length byte
	inc	de		; skip 2nd length byte
	ld	hl,prog2	; program data

	ld	bc,9		; program data length
	ldir			; copy data
	ret			; all done!

progname1:
	.db PROGOBJ,"ZJAMES",0
prog1:
	.db "CD5547C9",tEnter
	.db tEnd,tEnter
	.db "0000",tEnter
	.db tEnd

progname2:
	.db PROGOBJ,"JAMES",0
prog2:
	.db tSendMBL,"9",tPrgm,"ZJAMES"


create:
	.db "Program Creator!",0
asmcreate:
	.db "Creating ASM...",0
basiccreate:
	.db "Creating BASIC...",0
*/
#endif /* _FOPEN_C LOADED */