#ifndef USGDVAR_H
#define USGDVAR_H

#ifndef __TI85__
#ifndef __Usgard__
#error !!! this file is only to be used on the TI85 running Usgard !!!
#endif
#endif

/* Functions declared in this header:

   var_new(char* name, char type, int size) - creates a new variable
   var_delete(char* name) - deletes a variable
   var_exec(char* name) - execute a variable
   var_get(char* name) - returns a pointer the given variable
   var_resize(char* name, int size) - resizes a variable
*/

var_new(name, type, size) char *name, type; int size; {
#asm
   ld  hl,2
   add hl,sp
   ld  c,(hl)
   inc hl
   ld  b,(hl)
   inc hl
   ld  d,(hl)
   inc hl
   inc hl
   call LD_HL_MHL
   ld  a,d
   call VAR_NEW
#endasm
}

var_delete(name) char* name; {
#asm
   ld  hl,2
   add hl,sp
   call LD_HL_MHL
   call VAR_DELETE
#endasm
}

var_exec(name) char* name; {
#asm
   ld  hl,2
   add hl,sp
   call LD_HL_MHL
   call VAR_EXEC
#endasm
}

var_get(name) char* name; {
#asm
   ld  hl,2
   add hl,sp
   call LD_HL_MHL
   call VAR_GET
#endasm
}

var_resize(name, size) char* name; int size; {
#asm
   ld  hl,2
   add hl,sp
   ld  c,(hl)
   inc hl
   ld  b,(hl)
   inc hl
   call LD_HL_MHL
   call VAR_RESIZE
#endasm
}

#endif