#ifndef __DELAY_C
#define __DELAY_C
/* Shouldn't it be that a delay routine isn't changing
   registers...
   The registers should be the same afer returning, what
   happens between the call and the ret, does'n matter

   So it's maybe a good idea to rewrite this routine...
*/


/* delay(n) - pauses for a 1/100th of a second */

delay(n) int n; {
#asm
	ld	hl,2
	add	hl,sp
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a
__fastdelay:
#endasm

/* Make TI-86 run about as fast as a 83 like delay */
#ifdef __TI86__
#asm
	add	hl,hl	; double time
delaycont:
#endasm
#endif

#ifdef __TI83__
#asm
delaycont:
	xor	a	; 4 clk
	inc	a	; 4 clk
;	out	(3),a	;11 clk ; this instruction is deleted
				;
	neg		; 8	; Because you better don't
	neg		; 8	; switch off the calc...
	ei		; 4 clk
#endasm
#endif


#asm
	halt
	dec	hl
	ld	a,h		; Quick test for HL != 0?
	or	l
	jr	nz,delaycont
#endasm
}

#endif
