#ifndef __ASSERT_H
#define __ASSERT_H

/* Assertion */

/* Low-level functions must be included */
#ifndef __TILOADED__
#error You must load TI.H when using ASSERT.H
#endif

#include <exit.c>           /* We use abort() */

_Assert(mesg)
	char *mesg;
{
	puts(mesg);
	puts(" -- assert fialed\n");
	abort();
}

#ifdef NDEBUG
        /* Does not work, can someone fix this:( */
	#define assert(test) ((void)0)
#else
	/* Macros */
	#define _STR(x) _VAL(x)
	#define _VAL(x) #x
	#define assert(test) if(!(test)) \
		(_Assert(__FILE__ ":" _STR(__LINE__) " " #test))
#endif
#endif
