un_prot(str) char str;
{
#asm
	call	_ZEROOOP1		; Clear OP1
					;
	ld	hl,2			; The string-pointer is
	add	hl,sp			;  at SP+2.
	call	LD_HL_MHL		; HL = pointer at (HL)
					;
	ld	de,OP1			; A = adress of OP1
	ld	a,05h			; The object type is 'program'
	ld	(de),a			; Store it in first byte of OP1
	ld	b,9			; Maximum B-1 bytes to copy
					;
u_prot_loop:
	inc	de			; next byte of OP1
	ld	a,(hl)			; get a byte of the string
	or	a			; if(A = 0), done copying
	jr	z,next_u_prot		;  goto next label
	ld	(de),a			; Store the byte in OP1+xx
	inc	hl			; Next byte of string
	dec	b			; Maximum B-1 times again
	jr	z,error_u_prot		; if(B = 0), ERROR!
	jr	u_prot_loop		; go back for next character
					;
next_remove:
	call	_CHKFINDSYM		; Search the VAT for the entry
					;  stored in OP1
	jr	c,error_remove		; if(error), jump...

#endasm
}

/*
main:
  ld	a, (hl)	;Get type.
  and	%00011111	;Mask out unneeded bits.
  cp   06h		;Protected?
  jr   z,program	
  cp   05h		;Un-protected?
  jr   z,program
  cp   01h		;List?
  jr   z, skip1
  cp   $0D		;Complex list?
  jr   z, skip1
  jr   quit

program:
  ld   a,06h		;Load protected.
  ld   (hl),a		;Change it!

skip1:
  dec	hl		;Past T	

  dec	hl		;Past DAL
  dec	hl		;Past DAH
  ld	b, (hl)	;To the size!
skip2:
  dec	hl
  djnz	skip2
  dec	hl
  jr	main		;Repeat!

quit:
  ret




program:

  ld   a,05h		;Load unprotected.
  ld   (hl),a		;Change it!
*/
