#ifndef __REVERSE_C
#define __REVERSE_C

/* Reverse a character string

   Small-C library, by Henk Poley (hpoley@dds.nl)
   (---no www addres---)

   Synopsis:
      *reverse(char *s)

   Description:
      It will reverse the string beginning at addres *s, and give
      a pointer (the adress) where the new string can be found.

   Example:
      bla = *reverse("hello I am a geek")

   Output:
      bla = "keeg a ma I olleh"

   Notes:
      o I didn't test this routine (hmmm).

      o This routine is ripped off the CCGB compiler for the Gameboy.

*/
/* ************************************************************ */
/* Reverse a character string */

*reverse(s) char *s;
{
  int i, j;
  char c;

  i = 0;
  j = strlen(s) - 1;
  while(i < j) {
    c = s[i];
    s[i] = s[j];
    s[j] = c;
    i++;
    j--;
  }
  return(s);
}
#endif
