#ifndef __STRCPY_C
#define __STRCPY_C

/*
 * Copy string s2 to s1.  s1 must be large enough.
 * return s1
 */

strcpy(s1, s2) char *s1, *s2; {
/* Ye old fast String Copy routine */
#asm
	ld	hl,2
	add	hl,sp
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
; Copy string DE to BC include 0 tremator at end
strcpy_loop:
	ld	a,(DE)		; Get byte
	ld	(BC),a		; Copy Byte

	and	a		; Is NULL termator?
	jr	z, strcpy_loop_end

	inc	bc		; No, then prepare fer next byte
	inc	de

	jr	strcpy_loop	; And loop to copy it
strcpy_loop_end:
#endasm
}

/* A strcpy()-routine I found
	Henk Poley
PS. Has nothing to do with above one...

strcpy(s, t) char *s, *t; {
  char *d;
  d = s;
  while (*s++ = *t++) ;
  return (d);
  }
*/
#endif