#ifdef __TI82__
#ifdef __CrASH__
#define RedrawScreen asm("\tCALL CR_GRBCopy\t\t;Fast copy screen elements\n")
#endif
#ifndef __CrASH__
#error Only fastcopy implementation on the TI-82 via CrASH
#endif
#endif

#ifdef __TI83__
#ifdef __Ion__
#define RedrawScreen asm("\tcall\tionFastCopy\t\t;Fast copy screen elements\n")
#endif
#ifndef __Ion__
#include <83fstcpy.c>
#define RedrawScreen asm("\tcall\tFastCopy\t\t;Fast copy screen elements\n")
#endif
#endif

#ifdef __TI8x__
#ifdef __Ion__
#define RedrawScreen asm("\tcall\tionFastCopy\t\t;Fast copy screen elements\n")
#endif
#ifndef __Ion__
#include <83fstcpy.c>	/* can use the same routine as TI83 */
#define RedrawScreen asm("\tcall\tFastCopy\t\t;Fast copy screen elements\n")
#endif
#endif

#ifdef __TI85__
#error Could somebody say me what to do with fastcopy in the TI85?
#endif

#ifdef __TI86__
#define RedrawScreen asm(";Do nothing because TI-86 takes care of updates for us\n")
#endif