#ifndef __INDEX_C
#define __INDEX_C

/* index routine (something like strcmp() )

   Small-C library, by Henk Poley (hpoley@dds.nl)
   (---no www addres---)

   Synopsis:
      index(char *s, char *t)

   Description:
      It will return the addres where *t is found in *s.

   Example:
      bla = (index("hello I am a geek","geek"))

   Output:
      bla = 13 (I think)

   Notes:
      o I didn't test this routine (hmmm). I don't know if the
        return(x) thing works.

      o This routine is ripped off the CCGB compiler for the Gameboy.

*/
/* ************************************************************ */
/* Index - find index of string t in s */

index(s,t) char *s, char *t;
{
  int i, j, k;

  for(i = 0; s[i] != EOS; i++) {
    k = 0;
    for(j = i; t[k] != EOS && s[j] == t[k]; i++)
      j++;
    if (t[k] == EOS)
      return(i);
  }
  return(-1);
}
#endif