#ifndef GRAY_C
#define GRAY_C
/*
gray_on() - enables grayscale immediately. Returns 1 on failure
gray_off() - disables grayscale. All interrupts installed AFTER the call to
   gray_on() must be removed prior to this call.
*/
grayon() {
#asm
   #fncall gray_on
   jr c,_gray_fail
   ld  hl,0
   ret
_gray_fail:
   ld  hl,1
   ret
#endasm
}

grayoff() {
#asm
   #fncall gray_off
#endasm
}

#endif