/* not C at all (except the getkey()). But very usefull
   to find new romcalls. I adapted it to a 'C' file so
   I can use all the the calls in asm83c.h */


main()
 {
 #asm
;	Search.asm looks in ROM for an instruction
;	------------------------------------------
;	very usefull I think...
;	(I had to adjust some things about the 'spelling'.
;	 So TASM understands it right.)
;		Henk Poley

	call	_runIndicOff
	call	_CLRLCDFULL
	call	_homeUp
	ld	hl,str
	call	_puts
	call	_newline

	call	HackRom			;<<----

;	call	_clrlcd
;	call	_clrtxtshd
;	call	_homeup

	call	_getkey			;to pause at the end...

	ret

str:	.db	"Scanning ROM...",0


;========================================

HackRom:
	call	GetOpcNum
	ld	hl,$0000
HackRomloop:
	ld	de,code_start
	ld	a,(hl)
	ld	b,a
	ld	a,(de)
	cp	b
	call	z,TestCode

	ld	de,$7FFF			; end of ROM (RAM starts at $8000)
	call	_cphlde
	ret	nc
	INC	HL

	jr	HackRomloop


#define	num_opc		TestCode+1

TestCode:
	ld	b,0		;# opcodes to test
	dec	hl
	dec	de
testloop:
	inc	hl
	inc	de
	ld	a,(hl)
	ld	c,a
	ld	a,(de)
	cp	c
	ret	nz			;continu search into ROM
	djnz	testloop

	push	hl

	ld	a,(num_opc)
	neg
	ld	c,a
	ld	b,255
	inc	bc
	add	hl,bc

	call	DispMatchingAddress
	call	_newline
	pop	hl
	ret


; HERE IS THE INSTRUCTION TO
; LOOK FOR

code_start:
	ld      a,h	;4
	or	$FF	;4	;complement (same as "OR FFh")
	ld	h,a	;4
	ld	a,l	;4
	or	$FF	;4	;complement
	ld	l,a	;4
	ret		;10
code_end:



GetOpcNum:
	ld	hl,code_end-code_start
	ld	a,l
	ld	(num_opc),a
	ret

DispMatchingAddress:
	push	hl
	ld	a,h
	call	_dispHex
	pop	hl
	ld	a,l
	call	_dispHex
	ret

;========================================



_dispHex:
	push	af
	sra	a
	sra	a
	sra	a
	sra	a
	and	%00001111
	ld	e,a
	ld	d,$00
	ld	hl,_hex
	add	hl,de
	ld	a,(hl)
	call	_putc
	pop	af
	and	%00001111
	ld	e,a
	ld	d,$00
	ld	hl,_hex
	add	hl,de
	ld	a,(hl)
	call	_putc
	ret


_hex:		.db	"0123456789ABCDEF"

 #endasm
 }