/* Adventures in Math
   Very Beta'ish

   Made for TI-83 (screen properties), but it will work propperly 
   on the other TI's (when compiled for that one, dh).

   I think I found a bug in the box() routine, so I'm not using box.c
  */

#include <ti.h>       /* general routines   */
#include <line.c>     /* line()             */
#include <fastcopy.h> /* RedrawScreen       */

#name "Adventures in Math"

main()
 {
 indicatoroff;    /* No nasty runindicator  */
 clrlcd;          /* Bright & sparkling LCD */
 Drw_3D_room(2,1);
 RedrawScreen;    /* Copy it to the LCD     */
 getkey();        /* Wait before quiting    */
 }


Drw_3D_room(room, items) char room, items;
 {
 line(0,0,0,48,PT_ON);   /* A bar at the left   */
 line(94,0,94,48,PT_ON); /* A bar at the right  */
 line(1,0,93,0,PT_ON);   /* A bar at the top    */
 line(1,48,93,48,PT_ON); /* A bar at the bottom */
 
 line(1,1,93,47,PT_ON);  /* Basic 3D room,    */
 line(1,47,93,1,PT_ON);  /* 2 lines and a     */
 box(24,12,71,36,PT_ON); /* box in the middle */

 switch(room)
   {
   case 1 : One_Room();
            break;
   case 2 : Two_Rooms();
            break;
   }

 switch(items)
   {
   case 1 : Door_close();
            break;
   case 2 : Door_open();
            break;
   }
 }


box(x1,y1,x2,y2,col) char x1,y1,x2,y2,col;
 {
 line(x1,y2,x2,y2,col);
 line(x1,y2,x1,y1,col);
 line(x1,y1,x2,y1,col);
 line(x2,y1,x2,y2,col);
 }

One_Room()
 {
 line(24,12,71,36,PT_OFF); /* You can see only one room deep */
 line(24,36,71,12,PT_OFF); /* so delete the middle cross     */
 }


Two_Rooms()
 {
 box(36,18,59,30,PT_ON);   /* You can see 2 rooms deep   */
 line(36,18,59,30,PT_OFF); /* so print a second room and */
 line(36,30,59,18,PT_OFF); /* deleted the unwanted lines */
 }


Door_close()
 {
 /* There is a closed door */
 }


Door_open()
 {
 /* There is an open door */
 }